#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		__python	/usr/bin/python3
%define		_varlib	        %{_var}/lib
#-----------------------------------------------------------------------------
Name		:	asterisk
Version		:	21.0.0
Release		:	14.8.0.0%{?dist}
Summary		:	The Open Source PBX

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	GPLv2
URL		:	http://downloads.asterisk.org/pub/telephony/asterisk/releases/

Source0		:	%{name}-%{version}.tar.gz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	cryptsetup-devel
BuildRequires	:	doxygen
BuildRequires	:	fontconfig
BuildRequires	:	glibc
BuildRequires	:	gsm-devel
BuildRequires	:	graphviz
BuildRequires	:	jansson		>= 2.12
BuildRequires	:	krb5-devel
BuildRequires	:	libilbc
BuildRequires	:	libedit-devel
BuildRequires	:	lsof
BuildRequires	:	mariadb
BuildRequires	:	ncurses-devel
BuildRequires	:	net-snmp-agent-libs
BuildRequires	:	openssl-devel
BuildRequires	:	opusfile-devel
BuildRequires	:	perl-CGI
BuildRequires	:	postgresql
BuildRequires	:	postgresql-server-devel
BuildRequires	:	%{__python}
BuildRequires	:	speex
BuildRequires	:	speexdsp
BuildRequires	:	unixODBC-devel
BuildRequires	:	fonts-type1-urw
BuildRequires	:	xorg-x11-fonts-Type1
BuildRequires	:	xmlstarlet
BuildRequires	:	zlib

Requires	:	cronie
Requires	:	diffutils
Requires	:	libuv
Requires	:	mariadb
Requires	:	perl-CGI
Requires	:	procmail
#-----------------------------------------------------------------------------
%description
'%{name}' is a complete PBX in software. It runs on Linux and provides
all of the features you would expect from a PBX and more. Asterisk
does voice over IP in three protocols, and can interoperate with
almost all standards-based telephony equipment using relatively
inexpensive hardware.

#-----------------------------------------------------------------------------
%files			
%defattr(-,%{name},%{name},-)
%attr (0755,%{name},%{name}) %{_sysconfdir}/rc.d/init.d/%{name}

%config(noreplace) %attr(-,root,root) %{_sysconfdir}/logrotate.d/asterisk
%dir %{_var}/log/%{name}
%dir %{_var}/log/%{name}/cdr-csv
%dir %{_var}/log/%{name}/cdr-custom

%{_sbindir}/ast*
%{_sbindir}/autosupport*
%{_sbindir}/r%{name}
%{_sbindir}/safe_%{name}

%{_libdir}/%{name}/modules/app_*.so
%{_libdir}/%{name}/modules/bridge_*.so
%{_libdir}/%{name}/modules/chan_*.so
%{_libdir}/%{name}/modules/cdr_*.so
%{_libdir}/%{name}/modules/cel_*.so
%{_libdir}/%{name}/modules/codec*.so
%{_libdir}/%{name}/modules/codec_*.manifest.xml
%{_libdir}/%{name}/modules/format*.so
%{_libdir}/%{name}/modules/func_*.so
%{_libdir}/%{name}/modules/pbx_*.so
%{_libdir}/%{name}/modules/res_*.so
%{_libdir}/lib%{name}ssl.so*
%{_libdir}/lib%{name}pj.so*

%{_defaultdocdir}/%{name}-%{version}/examples/*.conf

%dir %{_varlib}/%{name}
%{_varlib}/%{name}/rest-api/*.json
%{_varlib}/%{name}/scripts/ast_*
%{_varlib}/%{name}/scripts/ref*.py


%{_varlib}/%{name}/moh/.asterisk-moh-opsound-wav-2.03
%{_varlib}/%{name}/moh/*-%{name}-moh-opsound-wav
%{_varlib}/%{name}/moh/*.wav
%attr(0755,%{name},%{name}) %dir %{_varlib}/%{name}/sounds
%{_varlib}/%{name}/sounds/en/.asterisk-core-sounds-en-gsm-1.6.1
%{_varlib}/%{name}/sounds/en/CHANGES-asterisk-core-en-1.6.1
%{_varlib}/%{name}/sounds/en/CREDITS-asterisk-core-en-1.6.1
%{_varlib}/%{name}/sounds/en/LICENSE-asterisk-core-en-1.6.1
%{_varlib}/%{name}/sounds/en/core-sounds-en.txt
%{_varlib}/%{name}/sounds/en/*.gsm
%{_varlib}/%{name}/sounds/en/dictate/*.gsm
%{_varlib}/%{name}/sounds/en/digits/*.gsm
%{_varlib}/%{name}/sounds/en/followme/*.gsm
%{_varlib}/%{name}/sounds/en/letters/*.gsm
%{_varlib}/%{name}/sounds/en/phonetic/*.gsm
%{_varlib}/%{name}/sounds/en/silence/*.gsm

%{_varlib}/%{name}/phoneprov/*.{cfg,xml}

%{_varlib}/%{name}/documentation/*
%{_varlib}/%{name}/images/*.jpg

%{_varlib}/%{name}/static-http/*.{css,html,js,xslt}
%{_varlib}/%{name}/static-http/core-en_US.xml

%{_var}/spool/%{name}/voicemail/default/1234/en/*.gsm


%{_mandir}/man8/*.8.gz
#-----------------------------------------------------------------------------
%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{name} stop > /dev/null 2>&1 || :
  /sbin/chkconfig --del %{name}
  /usr/sbin/userdel %{name}
  (
  /bin/echo -n "%{name}-%{version}-%{release} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%pre
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{name}

  /usr/sbin/useradd 				\
	-r					\
	-c "%{name} PBX Server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{name}				\
	-s /bin/bash				\
	-d %{_varlib}/%{name}			\
	%{name}
  fi

#building application
%postun
/usr/sbin/ldconfig

%post
/usr/sbin/ldconfig
/sbin/chkconfig --add %{name}
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		demo-config
Summary		:	Config files for a simple Asterisk configuration

#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		demo-config
asterisk config file for a working demo setup

#-----------------------------------------------------------------------------
%files			demo-config
%defattr(-,%{name},%{name},-)
%{_sysconfdir}/%{name}/README
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.adsi
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/cdr.conf
%config(noreplace) %{_sysconfdir}/%{name}/queues.conf
%config(noreplace) %{_sysconfdir}/%{name}/cdr_custom.conf
%config(noreplace) %{_sysconfdir}/%{name}/confbridge.conf
%config(noreplace) %{_sysconfdir}/%{name}/extensions.ael
%config(noreplace) %{_sysconfdir}/%{name}/extensions.conf
%config(noreplace) %{_sysconfdir}/%{name}/extensions.lua
%config(noreplace) %{_sysconfdir}/%{name}/indications.conf
%config(noreplace) %{_sysconfdir}/%{name}/logger.conf
%config(noreplace) %{_sysconfdir}/%{name}/modules.conf
%config(noreplace) %{_sysconfdir}/%{name}/musiconhold.conf
%config(noreplace) %{_sysconfdir}/%{name}/pjsip.conf
%config(noreplace) %{_sysconfdir}/%{name}/pjsip_notify.conf
%config(noreplace) %{_sysconfdir}/%{name}/ss7.timers
%config(noreplace) %{_sysconfdir}/%{name}/telcordia-1.adsi
%config(noreplace) %{_sysconfdir}/%{name}/voicemail.conf

#=============================================================================
%package		odbc
Summary		:	Applications for Asterisk that use ODBC (except voicemail)


#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}
Requires	:	unixODBC
Requires	:	mariadb-connector-odbc
#-----------------------------------------------------------------------------
%description		odbc
Applications for Asterisk that use ODBC (except voicemail)


#-----------------------------------------------------------------------------
%files			odbc
%defattr(-,%{name},%{name},-)
%{_libdir}/%{name}/modules/cdr_adaptive_odbc.so
%{_libdir}/%{name}/modules/cdr_odbc.so
%{_libdir}/%{name}/modules/cel_odbc.so
%{_libdir}/%{name}/modules/func_odbc.so
%{_libdir}/%{name}/modules/res_config_odbc.so
%{_libdir}/%{name}/modules/res_odbc.so
%{_libdir}/%{name}/modules/res_odbc_transaction.so

#-----------------------------------------------------------------------------
%define	lodbcso	cdr_odbc res_odbc res_config_odbc func_odbc func_global res_odbc_transaction app_voicemail_odbc
%define	nodbcso	app_voicemail
%preun			odbc
if [ $1 = 0 ]; then
  for od in %{lodbcso}
    do
    sed -i						\
	-e "s:^load => $od.so:noload => $od.so:"	\
	%{_sysconfdir}/%{name}/modules.conf
    done
  for od in %{nodbcso}
    do
    sed -i						\
	-e "s:^noload => $od.so:load => $od.so:"	\
	%{_sysconfdir}/%{name}/modules.conf
    done
  fi

%post			odbc
for od in %{lodbcso}
  do
  sed -i						\
	-e "s:^noload => $od.so:load => $od.so:"	\
	%{_sysconfdir}/%{name}/modules.conf
  done
for od in %{nodbcso}
  do
  sed -i						\
	-e "s:^load => $od.so:noload => $od.so:"	\
	%{_sysconfdir}/%{name}/modules.conf
  done
%{_sysconfdir}/rc.d/init.d/%{name} condrestart > /dev/null 2>&1 || :

#=============================================================================
%package		sounds-fr
Summary		:	Asterisk French sounds files


#-----------------------------------------------------------------------------
Requires	:	%{name}	= %{version}-%{release}

#-----------------------------------------------------------------------------
%description		sounds-fr
Files needed by asterisk to play french messages


#-----------------------------------------------------------------------------
%files			sounds-fr
%defattr(-,%{name},%{name},-)
%attr(0755,%{name},%{name}) %dir %{_varlib}/%{name}/sounds
%{_varlib}/%{name}/sounds/fr/.asterisk-core-sounds-fr-gsm-1.6.1
%{_varlib}/%{name}/sounds/fr/CHANGES-asterisk-core-fr-1.6.1
%{_varlib}/%{name}/sounds/fr/CREDITS-asterisk-core-fr-1.6.1
%{_varlib}/%{name}/sounds/fr/LICENSE-asterisk-core-fr-1.6.1
%{_varlib}/%{name}/sounds/fr/core-sounds-fr.txt
%{_varlib}/%{name}/sounds/fr/*.gsm
%{_varlib}/%{name}/sounds/fr/dictate/*.gsm
%{_varlib}/%{name}/sounds/fr/digits/*.gsm
%{_varlib}/%{name}/sounds/fr/followme/*.gsm
%{_varlib}/%{name}/sounds/fr/letters/*.gsm
%{_varlib}/%{name}/sounds/fr/phonetic/*.gsm
%{_varlib}/%{name}/sounds/fr/silence/*.gsm
%{_var}/spool/%{name}/voicemail/default/1234/fr/*.gsm

#=============================================================================
%prep
%setup -q
tar xf %{SOURCE1}

%{__cp} -a						\
	%{name}-ok_addon/sounds/asterisk-*.tar.gz	\
	sounds

%{__cp} -a						\
	%{name}-ok_addon/downloads/pjproject-*.bz2	\
	/tmp
#-----------------------------------------------------------------------------
#building application
%build

sed -i							\
  -e '1s/env python/python3/'				\
  contrib/scripts/refcounter.py

./bootstrap.sh

pushd menuselect
./configure

popd


./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--datadir=%{_datadir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--localstatedir=%{_var}				\
	--with-ilbc=%{_prefix}				\
	--with-libedit=yes				\
	--with-pjproject-bundled			\

#Must use the bundled pjproject
%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make}						\
	menuselect.makeopts

#making sure to have voicemail over odbc capability
#	-enable app_voicemail_odbc
#making sure to have fr sound
#	--enable CORE-SOUNDS-FR-GSM

./menuselect/menuselect					\
	 	--disable BUILD_NATIVE			\
		--enable CORE-SOUNDS-FR-GSM		\
		--enable codec_speex			\
		--enable app_voicemail_odbc		\
		--enable codec_opus			\
		--enable codec_silk			\
		--enable codec_siren7			\
		--enable codec_siren14			\

%{__make}						\
	%{_smp_mflags}					\

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install


#generating a full asterisk configuration example
%{__make}						\
	DESTDIR=%{buildroot}				\
	samples

%{__mkdir_p}						\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/examples
%{__mv}							\
	%{buildroot}%{_sysconfdir}/%{name}/*.conf	\
	%{buildroot}%{_defaultdocdir}/%{name}-%{version}/examples

%{__make}						\
	DESTDIR=%{buildroot}				\
	basic-pbx

%{__make}						\
	DESTDIR=%{buildroot}				\
	progdocs

%{__mkdir_p}						\
	%{buildroot}%{_sysconfdir}/logrotate.d		\
	%{buildroot}%{_var}/log/cdr-csv			\
	%{buildroot}%{_var}/log/cdr-custom

%{__cp} -a						\
	%{name}-ok_addon/logrotate			\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{name}

#creating start/stop procedure
%{__mkdir_p} %{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a						\
	%{name}-ok_addon/%{name}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d/%{name}


#-----------------------------------------------------------------------------
%changelog
